{% extends "base.html" %}
{% load static %}
{% load i18n %}
{% load applications %}

{% block styles %}
    <link rel="stylesheet" href="{% static 'plugins/datatables-bs4/css/dataTables.bootstrap4.min.css' %}">
    <link rel="stylesheet" href="{% static 'plugins/datatables-responsive/css/responsive.bootstrap4.min.css' %}">
{% endblock %}

{% block scripts %}
    <script src="{% static 'plugins/datatables/jquery.dataTables.js' %}"></script>
    <script src="{% static 'plugins/datatables-bs4/js/dataTables.bootstrap4.js' %}"></script>
    <script>
        {% if general_parameter.jitsi_enable %}
            function redirect_jitsi() {
                window.location.href = new URL(document.getElementById('jitsi_meeting_name').value,
                    '{{ general_parameter.jitsi_url }}');
            }
        {% endif %}

        jQuery(function () {
            const dataTable_general_rooms = jQuery('#general_rooms_overview').DataTable({
                lengthChange: false,
                paging: false,
                dom: 't',
                stateSave: true,
            });
            const dataTable_personal_rooms = jQuery('#personal_rooms_overview').DataTable({
                lengthChange: false,
                paging: false,
                dom: 't',
                stateSave: true,
            });

            const dataTable_home_rooms = jQuery('#home_rooms_overview').DataTable({
                lengthChange: false,
                paging: false,
                dom: 't',
                stateSave: true,
            });

            jQuery('#search_general_rooms').keyup(function () {
                dataTable_general_rooms.search(this.value).draw();
            });
            jQuery('#search_personal_rooms').keyup(function () {
                dataTable_personal_rooms.search(this.value).draw();
            });
            jQuery('#search_home_rooms').keyup(function () {
                dataTable_home_rooms.search(this.value).draw();
            });
        });

        function deletePersonalRoom(url) {
            jQuery('#delete_personal_room').attr('href', url);
            jQuery('#delete_personal_room_modal').modal('toggle');
        }

        function copyRoomLinkToClipboard(roomRelativeLink) {
            copyToClipboard(new URL(roomRelativeLink, '{{ base_url }}').toString()).then(function () {
                toastr.success('The content has successfully been copied to the clipboard.'); // TODO translation
            }, function () {
                toastr.error('Your Browser does not support copying to the clipboard.'); // TODO translation
            });
        }

        function inviteToRoomViaEmail(roomName, roomRelativeLink) {
            const roomLink = new URL(roomRelativeLink, '{{ base_url }}').toString();
            const subject = "{% trans "Invitation to" %} " + roomName;
            const body = "Hi eLearning Friend,\r\n\r\nlets meet at " + roomName + "." +
                " Please open " + roomLink + " with your Browser."; // TODO translation
            const mailto = new URL('mailto:');

            mailto.search = 'subject=' + encodeURIComponent(subject) + '&body=' + encodeURIComponent(body);
            const mailtoTap = window.open(mailto.toString(), '_blank');
            if (mailtoTap) {
                mailtoTap.close();
            }
        }
    </script>

    {% if_app_installed 'support_chat' %}
        {% if request.user.is_authenticated %}
            <script>
                window.addEventListener('load', function () {
                    const chat = new Chat('/ws/supportchat', {{ disable_chat_if_offline }}, {{ support_chat_message_max_length }});
                    chat.open();
                    jQuery('#support-chat').append(chat.getCard());
                });
            </script>
        {% endif %}
    {% end_if_app_installed %}
{% endblock %}

{% block content %}
    {% if general_parameter.latest_news %}
        <div class="alert alert-danger alert-dismissible">
            <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
            <h5><em class="icon fas fa-info"></em> {% trans "Latest News!" %}</h5>
            {{ general_parameter.latest_news|safe }}
        </div>
    {% endif %}


    <div class="row">
        {% if general_parameter.jitsi_enable %}
            <div class="col-lg-3 col-md-6 col-sm-12">
                <div class="info-box mb-3">
                    <span class="info-box-icon bg-gradient-secondary elevation-1"><em
                            class="fas fa-broadcast-tower"></em></span>
                    <div class="info-box-content">
                        <span class="info-box-text">{% trans "Create ad-hoc Jitsi meeting" %}</span>
                        <span class="info-box-number">
                                <a class="lbtn-link" data-toggle="modal" data-target="#modal-default" href="">
                                    {% trans "Start" %}
                                </a>
                        </span>
                    </div>
                </div>
            </div>
        {% endif %}

        {% if user.homeroom %}
            <div class="col-lg-3 col-md-6 col-sm-12">
                <div class="info-box mb-3">
                    <span class="info-box-icon bg-primary elevation-1"><em class="fas fa-home"></em></span>
                    <div class="info-box-content">
                        <span class="info-box-text">{% trans "Your personal home room" %}</span>
                        <span class="info-box-number">
                            <span style="white-space: nowrap;" class="mr-2">
                            <em class="far fa-sm fa-copy" style="cursor: pointer;"
                                onclick="copyRoomLinkToClipboard('{% url 'join_redirect' user.homeroom.name %}')"
                                data-toggle="tooltip" data-placement="top"
                                title="{% translate "Copy room link" %}"></em>
                            <a class="text-body" href="{% url 'home_room_update' user.homeroom.pk %}">
                                    <em class="fas fa-pen"
                                        data-toggle="tooltip" data-placement="top"
                                        title="{% translate "Edit" %}"></em>
                                </a>
                            </span>

                            <a href="{% url 'join_or_create_meeting' user.homeroom.meeting_id %}">
                                {% trans "Start" %}
                            </a>
                        </span>
                    </div>
                </div>
            </div>
        {% endif %}
        {% if general_parameter.personal_rooms_enabled %}
            {% for room in user.personalroom_set.all %}
                <div class="col-lg-3 col-md-6 col-sm-12">
                    <div class="info-box mb-3 ">
                        <span class="info-box-icon bg-success elevation-1"><em
                                class="fas fa-chalkboard-teacher"></em></span>
                        <div class="info-box-content">
                            <span class="info-box-text">{{ room.name }}</span>
                            <span class="info-box-number">
                                <span style="white-space: nowrap;" class="mr-2">
                                <em class="far fa-sm fa-copy" style="cursor: pointer;"
                                    onclick="copyRoomLinkToClipboard('{% url 'join_redirect' room.name %}')"
                                    data-toggle="tooltip" data-placement="top"
                                    title="{% translate "Copy room link" %}"></em>
                                <a class="text-body" href="{% url 'personal_room_update' room.pk %}">
                                    <em class="fas fa-pen"
                                        data-toggle="tooltip" data-placement="top"
                                        title="{% translate "Edit" %}"></em>
                                </a>
                                <em class="fas fa-sm fa-trash-alt" style="cursor: pointer;"
                                    onclick="deletePersonalRoom('{% url "personal_room_delete" room.pk %}')"
                                    data-toggle="tooltip" data-placement="top"
                                    title="{% trans "Delete" %}"></em>
                                </span>
                                <a href="{% url 'join_or_create_meeting' room.meeting_id %}">
                                    {% trans "Start" %}
                                </a>
                            </span>
                        </div>
                    </div>
                </div>
            {% endfor %}
            {% for room in user.co_owners.all %}
                <div class="col-lg-3 col-md-6 col-sm-12">
                    <div class="info-box mb-3">
                        <span class="info-box-icon bg-success elevation-1"><em class="fas fa-user-friends"></em></span>
                        <div class="info-box-content">
                            <span class="info-box-text">{{ room.name }}</span>
                            <span class="info-box-number">
                                <span style="white-space: nowrap;" class="mr-2">
                                <em class="far fa-sm fa-copy" style="cursor: pointer;"
                                    onclick="copyRoomLinkToClipboard('{% url 'join_redirect' room.name %}')"
                                    data-toggle="tooltip" data-placement="top"
                                    title="{% translate "Copy room link" %}"></em>
                                <a class="text-body" href="{% url 'personal_room_update' room.pk %}">
                                    <em class="fas fa-pen"
                                        data-toggle="tooltip" data-placement="top"
                                        title="{% translate "Edit" %}"></em>
                                </a>
                                </span>
                                <a href="{% url 'join_or_create_meeting' room.meeting_id %}">
                                    {% trans "Start" %}
                                </a>
                            </span>
                        </div>
                    </div>
                </div>
            {% endfor %}
            {% if user.personalroom_set.all.count < user.get_max_number_of_personal_rooms %}
                <div class="col-lg-3 col-md-6 col-sm-12">
                    <div class="info-box mb-3">
                        <a class="info-box-icon bg-gray elevation-1" href="{% url 'personal_room_create' %}">
                            <em class="fas fa-plus"></em>
                        </a>
                        <div class="info-box-content">
                            <span class="info-box-text">{% trans "Create new personal room" %}</span>
                        </div>
                    </div>
                </div>
            {% elif user.get_max_number_of_personal_rooms > 0 %}
                <div class="col-lg-3 col-md-6 col-sm-12">
                    <div class="info-box mb-3">
                        <em class="fas fa-times info-box-icon bg-gray elevation-1"></em>
                        <div class="info-box-content">
                            <span class="info-box-text">{% trans "Maximum number of personal rooms created" %}</span>
                        </div>
                    </div>
                </div>
            {% endif %}
        {% endif %}
    </div>

    <div class="row">
        <div class="col-md-12">
            <div class="card-header">
                <ul class="nav nav-tabs card-header-tabs" id="bologna-list" role="tablist">
                    <li class="nav-item">
                        <a class="nav-link active" href="#generalrooms" data-toggle="tab" role="tab"
                           aria-controls="description"
                           aria-selected="true">{% trans "General Rooms" %}</a>
                    </li>
                    {% if general_parameter.personal_rooms_enabled %}
                        <li class="nav-item">
                            <a class="nav-link" href="#personalrooms" data-toggle="tab" role="tab"
                               aria-controls="history"
                               aria-selected="false">{% trans "Personal Rooms" %}</a>
                        </li>
                    {% endif %}
                    {% if general_parameter.home_room_enabled %}
                        <li class="nav-item">
                            <a class="nav-link" href="#homerooms" data-toggle="tab" role="tab" aria-controls="deals"
                               aria-selected="false">{% trans "Home Rooms" %}</a>
                        </li>
                    {% endif %}
                </ul>
            </div>
            <div class="card">
                <div class="card-body">
                    <div class="tab-content mt-3">
                        <div class="tab-pane active" id="generalrooms" role="tabpanel">
                            <!-- Content -->
                            <label>{% trans "Overview of available rooms" %}</label>
                            <div class="col-md-12">
                                <div class="card-header">
                                    <div class="card-title w-100 mb-2">
                                        <label for="search_general_rooms"></label>
                                        <input class="form-control" id="search_general_rooms"
                                               placeholder="{% translate "Search room..." %}" type="text"
                                               autofocus="autofocus">
                                    </div>
                                </div>
                                <div class="card-body">
                                    <div class="table-responsive">
                                        <table id="general_rooms_overview"
                                               class="table table-sm table-hover table-borderless">
                                            <caption>{% trans "Overview of available rooms" %}</caption>
                                            <thead class="thead-light">
                                            <tr>
                                                <th scope="col" style="width: 40px"></th>
                                                <th scope="col">{% trans "Room" %}</th>
                                                <th scope="col">{% trans "State" %}</th>
                                                <th scope="col">{% trans "Configuration" %}</th>
                                                {% if general_parameter.enable_occupancy %}
                                                    <th scope="col"
                                                        class="d-none d-lg-table-cell">{% trans "Current Occupancy" %}</th>
                                                    <th scope="col"
                                                        class="d-none d-lg-table-cell">{% trans "Next Occupancy" %}</th>
                                                {% endif %}
                                                <th scope="col"
                                                    class="d-none d-lg-table-cell">{% trans "Participants" %}</th>
                                                <th scope="col"
                                                    class="d-none d-lg-table-cell">{% trans "Comment" %}</th>
                                            </tr>
                                            </thead>
                                            <tbody>
                                            {% for room in rooms %}
                                                {% if room.is_public %}
                                                    {% if not room.is_breakout and room.config and room.is_room_only %}
                                                        <tr>
                                                            <td> <span style="white-space: nowrap;">
                                                            <em class="far fa-sm fa-copy" style="cursor: pointer;"
                                                                onclick="copyRoomLinkToClipboard('{% url 'join_redirect' room.name %}')"></em>
                                                            <em class="far fa-sm fa-envelope" style="cursor: pointer;"
                                                                onclick="inviteToRoomViaEmail('{{ room.name }}', '{% url 'join_redirect' room.name %}')"></em>
                                                            </span>
                                                            </td>
                                                            <td>
                                                                <a href="{% url 'join_or_create_meeting' room.meeting_id %}">{{ room.name }}</a>
                                                            </td>
                                                            <td>
                                                                {% include 'snippet_room_state.html' with state=room.state %}
                                                            </td>
                                                            <td>{{ room.config.name }}</td>
                                                            {% if general_parameter.enable_occupancy %}
                                                                <td class="d-none d-lg-table-cell">
                                                                    {{ room.room_occupancy_current|default_if_none:"" }}
                                                                </td>
                                                                <td class="d-none d-lg-table-cell">
                                                                    {{ room.room_occupancy_next|default_if_none:"" }}
                                                                </td>
                                                            {% endif %}
                                                            <td class="d-none d-lg-table-cell">
                                                                {{ room.participant_count }}
                                                            </td>
                                                            <td class="d-none d-lg-table-cell">
                                                                {{ room.comment_public|default_if_none:"" }}
                                                            </td>
                                                        </tr>
                                                    {% endif %}
                                                {% endif %}
                                            {% endfor %}
                                            </tbody>
                                        </table>
                                    </div>
                                </div>
                            </div>
                        </div>


                        {% if general_parameter.personal_rooms_enabled %}
                            <div class="tab-pane" id="personalrooms" role="tabpanel" aria-labelledby="history-tab">
                                <!-- Content -->
                                <label>{% trans "Overview of rooms created by users (personal rooms) and marked as publically visible." %}</label>

                                <div class="col-md-12">
                                    <div class="card-header">
                                        <div class="card-title w-100 mb-2">
                                            <label for="search_personal_rooms"></label>
                                            <input class="form-control" id="search_personal_rooms"
                                                   placeholder="{% translate "Search room..." %}" type="text"
                                                   autofocus="autofocus">
                                        </div>
                                    </div>
                                    <div class="card-body">
                                        <div class="table-responsive">
                                            <table id="personal_rooms_overview"
                                                   class="table table-sm table-hover table-borderless">
                                                <caption>{% trans "Overview of rooms created by users (personal rooms) and marked as publically visible." %}</caption>
                                                <thead class="thead-light">
                                                <tr>
                                                    <th scope="col" style="width: 20px"></th>
                                                    <th scope="col">{% trans "Name" %}</th>
                                                    <th scope="col">{% trans "Owner" %}</th>
                                                    <th scope="col">{% trans "State" %}</th>
                                                    <th scope="col">{% trans "Configuration" %}</th>
                                                    <th scope="col"
                                                        class="d-none d-lg-table-cell">{% trans "Participants" %}</th>
                                                    <th scope="col"
                                                        class="d-none d-lg-table-cell">{% trans "Comment" %}</th>
                                                </tr>
                                                </thead>
                                                <tbody>
                                                {% for room in rooms %}
                                                    {% if room.is_public %}
                                                        {% if not room.is_breakout and room.config and room.is_personalroom %}
                                                            <tr>
                                                                <td> <span style="white-space: nowrap;">
                                                                <em class="far fa-sm fa-copy" style="cursor: pointer;"
                                                                    onclick="copyRoomLinkToClipboard('{% url 'join_redirect' room.name %}')"></em>
                                                                </span>
                                                                </td>
                                                                <td>
                                                                    <a href="{% url 'join_or_create_meeting' room.meeting_id %}">
                                                                        {{ room.name }} </a>
                                                                </td>
                                                                <td>
                                                                    <a href="{% url 'join_or_create_meeting' room.meeting_id %}">
                                                                        {{ room.personalroom.owner.last_name }}{{ ", " }}{{ room.personalroom.owner.first_name }}</a>
                                                                </td>
                                                                <td>
                                                                    {% include 'snippet_room_state.html' with state=room.state %}
                                                                </td>
                                                                <td>{{ room.config.name }}</td>
                                                                <td class="d-none d-lg-table-cell">
                                                                    {{ room.participant_count }}
                                                                </td>
                                                                <td class="d-none d-lg-table-cell">
                                                                    {{ room.comment_public|default_if_none:"" }}
                                                                </td>
                                                            </tr>
                                                        {% endif %}
                                                    {% endif %}
                                                {% endfor %}
                                                </tbody>
                                            </table>
                                        </div>
                                    </div>
                                </div>
                            </div>

                        {% endif %}
                        {% if general_parameter.home_room_enabled %}
                            <div class="tab-pane" id="homerooms" role="tabpanel" aria-labelledby="deals-tab">
                                <!-- Content -->
                                <label>{% trans "Overview of home rooms that have been marked as publically visible." %}</label>

                                <div class="col-md-12">
                                    <div class="card-header">
                                        <div class="card-title w-100 mb-2">
                                            <label for="search_home_rooms"></label>
                                            <input class="form-control" id="search_home_rooms"
                                                   placeholder="{% translate "Search room..." %}"
                                                   type="text"
                                                   autofocus="autofocus">
                                        </div>
                                    </div>
                                    <div class="card-body">
                                        <div class="table-responsive">
                                            <table id="home_rooms_overview"
                                                   class="table table-sm table-hover table-borderless">
                                                <caption>{% trans "Overview of home rooms that have been marked as publically visible." %}</caption>
                                                <thead class="thead-light">
                                                <tr>
                                                    <th scope="col" style="width: 20px"></th>
                                                    <th scope="col">{% trans "Owner" %}</th>
                                                    <th scope="col">{% trans "State" %}</th>
                                                    <th scope="col">{% trans "Configuration" %}</th>
                                                    <th scope="col"
                                                        class="d-none d-lg-table-cell">{% trans "Participants" %}</th>
                                                    <th scope="col"
                                                        class="d-none d-lg-table-cell">{% trans "Comment" %}</th>
                                                </tr>
                                                </thead>
                                                <tbody>
                                                {% for room in rooms %}
                                                    {% if room.is_public %}
                                                        {% if not room.is_breakout and room.config and room.is_homeroom %}
                                                            <tr>
                                                                <td> <span style="white-space: nowrap;">
                                                                <em class="far fa-sm fa-copy" style="cursor: pointer;"
                                                                    onclick="copyRoomLinkToClipboard('{% url 'join_redirect' room.name %}')"></em>
                                                                </span>
                                                                </td>
                                                                <td>
                                                                    <a href="{% url 'join_or_create_meeting' room.meeting_id %}">
                                                                        {{ room.homeroom.owner.last_name }}{{ ", " }}{{ room.homeroom.owner.first_name }}</a>
                                                                </td>
                                                                <td>
                                                                    {% include 'snippet_room_state.html' with state=room.state %}
                                                                </td>
                                                                <td>{{ room.config.name }}</td>
                                                                <td class="d-none d-lg-table-cell">
                                                                    {{ room.participant_count }}
                                                                </td>
                                                                <td class="d-none d-lg-table-cell">
                                                                    {{ room.comment_public|default_if_none:"" }}
                                                                </td>
                                                            </tr>
                                                        {% endif %}
                                                    {% endif %}
                                                {% endfor %}
                                                </tbody>
                                            </table>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        {% endif %}
                    </div>
                </div>
            </div>
        </div>
    </div>

    {% if general_parameter.personal_rooms_enabled %}
        <div id="delete_personal_room_modal" class="modal fade" tabindex="-1" role="dialog"
             aria-labelledby="CenterModalLabel"
             aria-hidden="true" style="display: none;">
            <div class="modal-dialog modal-dialog-centered">
                <div class="modal-content">
                    <div class="modal-header">
                        <h4 class="modal-title" id="CenterModalLabel">{% trans "Delete personal room" %}</h4>
                        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
                    </div>
                    <div class="modal-body">
                        {% trans "Are you sure you want to delete the personal room?" %}
                    </div>
                    <div class="modal-footer">
                        <a class="btn btn-danger" href=""
                           data-toggle="tooltip" data-placement="top" title="{% translate "Delete" %}"
                           id="delete_personal_room">
                            {% trans "Delete" %}
                        </a>
                        <button type="button" class="btn btn-secondary waves-effect"
                                data-dismiss="modal">{% trans "Cancel" %}</button>
                    </div>
                </div><!-- /.modal-content -->
            </div><!-- /.modal-dialog -->
        </div>
    {% endif %}

    {% if general_parameter.jitsi_enable %}
        <div class="modal fade" id="modal-default">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h4 class="modal-title">{% trans "Create ad-hoc meeting" %}</h4>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <em class="fas fa-times"></em>
                        </button>
                    </div>
                    <div class="modal-body">
                        <label for="jitsi_meeting_name">
                            {% trans "Please provide a name for your adhoc meeting room." %}
                        </label>
                        <input type="text" class="form-control" id="jitsi_meeting_name" placeholder="room name"
                               required>
                    </div>
                    <div class="modal-footer justify-content-between">
                        <button type="button" class="btn btn-light waves-effect"
                                data-dismiss="modal">{% trans "Close" %}</button>
                        <button type="button" class="btn btn-primary waves-effect waves-light"
                                onclick="redirect_jitsi()">
                            {% trans "Create room" %}
                        </button>
                    </div>
                </div>
                <!-- /.modal-content -->
            </div>
            <!-- /.modal-dialog -->
        </div>
    {% endif %}

    {% if_app_installed 'support_chat' %}
        {% if request.user.is_authenticated %}
            <div id="support-chat" class="modal-content fixed-bottom border-right-0 border-bottom-0"
                 style="left: unset; max-width: 500px">
            </div>
        {% endif %}
    {% end_if_app_installed %}
{% endblock %}
